import java.awt.*;
import java.lang.*;
import java.io.*;

	class Estoc2Gui extends Frame {
		TextField a1,a2,a3;
		Button c1,c2,c3;
		Label l1,l2,l3;
		Estoc2Calculs calcul = null ;
		SimpleDataViewer sdv = null;
		String nom = "sensenom.dat";
		float a = 0.8f;
		int i = 100;
		int max = 100;

		Estoc2Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(a));
			a2 = new TextField(Integer.toString(i));
			a3 = new TextField(Integer.toString(max));
			c1 = new Button("Calcula");
			c2 = new Button("Desa");
			c3 = new Button("Abandona");
			l1 = new Label("Parametre a");
			l2 = new Label("Nombre inicial");
			l3 = new Label("Nombre de passos");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcula"))
				calcular();
			if(label.equals("Desa"))
				guardar();
			if(label.equals("Abandona"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1;
			double x0[],y0[];
			int m;

			if(sdv!=null)sdv.hide();
			sdv = new SimpleDataViewer("Visor de dades",1);
			sdv.init();
			sdv.tpt.frameWidth = 475;
			sdv.tpt.tickSeparation1 = 20;
			sdv.tpt.tickSeparation2 = 40;
			sdv.grf.lx = "Pas de temps";
			sdv.grf.ly = "Nombre d'individus";

			f1 = Float.valueOf(a1.getText());
			a = f1.floatValue();
			i = Integer.parseInt(a2.getText());
			max = Integer.parseInt(a3.getText());
			calcul = new Estoc2Calculs(a,i,max);
			c2.enable();

			x0 = new double[max];
			y0 = new double[max];
			for(m=0;m<max;m++) {
				x0[m] = (double) m;
				y0[m] = calcul.traj[m];
			}
			sdv.grf.cjt[0].initializeColor(1);
			sdv.grf.cjt[0].initializeCoordinates(x0,y0);
			sdv.grf.cjt[0].pointType=2;
			sdv.show();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						for(m=0;m<max;m++) {
							linia=Integer.toString(m) + " " + Double.toString(calcul.traj[m]) + "\n";
							sortida.write(linia);
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Estoc2DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Estoc2DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Desa",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Estoc2DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Estoc2DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirma",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.la");
			l1 = new Label ("  El fitxer ja existeix. Vols escriure a sobre?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.la")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Estoc2 {

	public static void main(String args[]) {
		Estoc2Gui estoc2 = null;		// Declaraci d'instncies.

		estoc2 = new Estoc2Gui("Estoc2");
		estoc2.init();
		estoc2.show();
	}
}

