import java.lang.*;

/*
-------------------------------------------------------------------------------
Aquest programa esta pensat per veure la relacio entre el model logistic
discret i continu
-------------------------------------------------------------------------------
Dades: R (factor de creixement), deltat (duracio del pas), K (capacitat del
       sistema), a (nombre inicial de membres de l'especie, sense normalitzar),
       max (nombre de passos)
Resultats: Al fitxer "logist2.dat". El resultat ve en quatre columnes. Les
           dues primeres son els resultats del model discret (temps i nombre
           d'individus). Les altres dues representen les mateixes quantitats
           pero utilitzant un model continu que en teoria es equivalent.
Dades de prova: R=1.5 deltat=1.0 K=500.0 a=10 max=2 ==> 0, 10.0, 0, 10.0;
                1, 14.9, 1, 14.851484; 2, 22.127991, 2, 21.951219
Observacions: Si tan sols estem interessats en el model logistic discret podem
              ignorar les dues darreres columnes.
              Si no compila be, fer-ho amb l'opcio -lm
-------------------------------------------------------------------------------
*/

public class Logist2Calculs {
	double R,K,a,deltat,traj1[],traj2[],traj3[];
	int max;

	Logist2Calculs(float R0,float deltat0,float K0,float a0,int max0) {
		double x,y,y0,r,t,Q;
		int n;

		R = (double) R0;
		deltat = (double) deltat0;
		K = (double) K0;
		a = (double) a0;
		max = max0;
		traj1 = new double[max];
		traj2 = new double[max];
		traj3 = new double[max];

/* Hipotesi 1 (Relacio entre la taxa i el factor de creixement) */

		r=Math.log(R)/deltat;

/* Hipotesi 2 (relacio entre les normalitzacions) */

		Q=K*((1.0/(R-1))+1.0);

		x=a/Q;
		y0=a/K;
		traj1[0] = a;
		traj2[0] = 0.0;
		traj3[0] = a;

		for(n=1;n<max;n++) {
			x=R*(1-x)*x;
        		t=n*deltat;
        		y=1.0/(1.0+((1.0/y0)-1.0)*Math.exp(-r*t));
			traj1[n] = x*Q;
			traj2[n] = t;
			traj3[n] = y*K;
		}
	}
}
